(function () {
    let url = ''
    let versionname = 'killMonsterDev';
    if (window.env == "production") {
        url = "http://soul.qihuan.tech/version/api/getVersion";
        versionname = "killMonsterPro"
    } else if (window.env == "demo") {
        url = "http://kmonster.qihuan.tech/version/api/getVersion";
        versionname = "killMonsterDemo"
    } else {
        url = "http://127.0.0.1:2813/api/getVersion";
        versionname = "killMonsterDev"
    }

    // window.onerror = function (message, source, lineno, colno, error) {
    //     // $('#msgerrorTip').text($('#msgerrorTip').text() + '#10')
    //     window.alert(message + source + lineno + colno + error)
    // }
    let totalFileAmount = 0;
    let nowFileAmount = 0;

    function addmsg(value) {
        $('#msgerrorTip').text($('#msgerrorTip').text() + ' === ' + value)
    }

    function loadCss(list, callback) {
        let loaded = 0;
        let loadNext = function () {
            let orginFileName = list[loaded][0];
            let fileName = list[loaded][1];
            // checkIfFileExists(orginFileName, fileName, (localfile) => {
            //     if (localfile == 0) {
            //         loadFile();
            //     } else if (typeof localfile == 'string') {


            //     }
            // })
            let text = window.Base64.decode(fileMapData[fileName])
            // let text =  fileMapData[fileName]
            loadSingleCssText(text, function () {
                loaded++;
                nowFileAmount++;
                document.getElementById('appUpdateText').innerHTML = "加载文件中" + nowFileAmount + '/' + totalFileAmount
                setTimeout(() => {
                    if (loaded >= list.length) {
                        callback();
                    } else {
                        loadNext();
                    }
                }, 30)
            })

            // loadSingleCss(fileUri, function () {
            // 	loaded++;
            // 	nowFileAmount++;
            // 	document.getElementById('appUpdateText').innerHTML = "加载文件中" + nowFileAmount +
            // 		'/' +
            // 		totalFileAmount
            // 	if (loaded >= list.length) {
            // 		callback();
            // 	} else {
            // 		loadNext();
            // 	}
            // })
        };
        loadNext();
    };

    function loadSingleCss(path, callback) {

        if (!path || path.length === 0) {
            return
        }
        addmsg('loadSingleCss' + path)
        var head = document.getElementsByTagName('head')[0];
        var link = document.createElement('link');
        link.href = path;
        link.rel = 'stylesheet';
        link.type = 'text/css';
        link.addEventListener('load', function () {
            callback();
        }, false);
        head.appendChild(link);
    }

    function loadSingleCssText(cssText, callback) {
        if (!cssText || cssText.length === 0) {
            return
        }
        var head = document.getElementsByTagName("head")[0];
        var style = document.createElement("style");
        var rules = document.createTextNode(cssText);
        style.type = "text/css";
        if (style.styleSheet) {
            style.styleSheet.cssText = rules.nodeValue;
        } else {
            style.appendChild(rules);
        }
        head.appendChild(style);
        callback();
    }


    var loadScript = function (list, callback) {
        var loaded = 0;
        var loadNext = function () {
            let orginFileName = list[loaded][0];
            let fileName = list[loaded][1];
            let text = window.Base64.decode(fileMapData[fileName])
            // let text =  fileMapData[fileName]
            loadSingleScriptText(text, function () {
                loaded++;
                nowFileAmount++;
                document.getElementById('appUpdateText').innerHTML = "加载文件中" + nowFileAmount + '/' + totalFileAmount
                setTimeout(() => {
                    if (loaded >= list.length) {
                        callback();
                    } else {
                        loadNext();
                    }
                }, 30)
            })
            // checkIfFileExists(orginFileName, fileName, (localfile) => {
            //     if (localfile == 0) {
            //         loadFile();
            //     } else if (typeof localfile == 'string') {

            //     }
            // })
            // loadSingleScript(fileUri, function () {
            // 	loaded++;
            // 	nowFileAmount++
            // 	document.getElementById('appUpdateText').innerHTML = "加载文件中" +
            // 		nowFileAmount + '/' +
            // 		totalFileAmount
            // 	if (loaded >= list.length) {
            // 		callback();
            // 	} else {
            // 		loadNext();
            // 	}
            // })
        };
        loadNext();
    };

    function loadSingleScript(src, callback) {
        var s = document.createElement('script');
        s.async = false;
        s.src = src;
        s.type = "module"

        s.addEventListener('load', function () {
            console.log(src)
            s.parentNode.removeChild(s);
            s.removeEventListener('load', arguments.callee, false);
            callback && callback();
        }, false);
        document.body.appendChild(s);
    };

    function loadSingleScriptText(text, callback) {
        if (!text || text.length === 0) {
            return
        }
        var head = document.getElementsByTagName("head")[0];
        var script = document.createElement("script");
        var rules = document.createTextNode(text);
        script.type = "text/javascript";
        script.appendChild(rules);
        head.appendChild(script);
        callback();
    }

    $(document).ready(function () {
        // $('#msgerrorTip').click(() => {
        //     window.alert($('#msgerrorTip').text())
        // })
               getFile();
    });

    document.addEventListener("deviceready", function () {
        getFile();
        document.addEventListener("backbutton", function () {
            navigator.notification.confirm(
                '确认退出？', // message
                (index) => {
                    if (index == 1) {
                        window["cordova"].plugins.myPlugin.logoutMethod()
                        navigator.app.exitApp()
                    }
                },
                '月光骑士', // title
                ['确认', '取消'] // buttonLabels
            );
        }, false);

    }, false);
    let _mainjs, _maincss, _mainjsurl, _maincssurl, fileMapData = {};
    let RootDirectory = cordova.file.externalDataDirectory;

    function getFile() {
        $('#appUpdateText').html("更新检测中")
        $.ajax({
            url: url,
            type: "POST",
            data: JSON.stringify({
                name: versionname
            }),
            timeout: 5000,
            success: (res) => {
                addmsg("检测成功")
                res = JSON.parse(res)
                console.log(res)
                var data = res.data;
                _mainjs = data.files.js[0]
                _maincss = data.files.css[0]
                if (window.mainjs == _mainjs && window.maincss == _maincss) {
                    loadSingleCss('./static/js/' + window.maincss, () => {
                        loadSingleScript('./static/js/' + window.mainjs)
                    })
                } else {
                    window.version = data.version
                    let zipfiles = data.zipfiles
                    fileMapData = {}
                    for (var i in zipfiles) {
                        let zipfile = zipfiles[i]
                        fileMapData[zipfile.fileName] = {
                            url: zipfile.url,
                            isexist: false,
                            size: zipfile.size
                        }
                    }
                    loadFile();
                }
            },
            error: (textStatus) => {
                // $('#appUpdateText').html("<div class='tryBtn'>请求失败,重试</div>")
                // addmsg("请求失败")
                // $('.tryBtn').click(function () {
                //     $(".tryBtn").unbind("click");
                //     $('#appUpdateText').html("请求服务器中")
                //     setTimeout(() => {
                //         getFile()
                //     }, 1000)
                // })
                loadSingleCss('./static/js/' + window.maincss, () => {
                    loadSingleScript('./static/js/' + window.mainjs)
                })
            }
        })
    }



    async function loadFile() {
        let res = await checkIfFileExists()
        for (let filename in fileMapData) {
            if (fileMapData[filename].isexist == false) {
                await downloadFile(fileMapData[filename].url, filename)
            }
        }
        let zipExtractDirectory = await getZipDirectory()
        window.jsUrl =  zipExtractDirectory.internalurl
      
        for (let filename in fileMapData) {
            let res = await ZipFile(fileMapData[filename].fileEntryURL, zipExtractDirectory.url)
        }
        await getFileUrl()
        if (_maincssurl && _mainjsurl) {
            document.getElementById('appUpdateText').innerHTML = "打开文件"
            loadSingleCss(_maincssurl, () => {
                document.getElementById('appUpdateText').innerHTML = "打开文件中"
                loadSingleScript(_mainjsurl, () => {
                    document.getElementById('appUpdateText').innerHTML = "进入游戏中"
                })
            })
        }else{
            document.getElementById('appUpdateText').innerHTML = "打开文件失败"
        }
    }


    function checkIfFileExists() {
        return new Promise(resolve => {
            window.resolveLocalFileSystemURL(cordova.file.externalDataDirectory,
                // window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,
                function (fs) {
                    fs.getDirectory("zipPath", {
                        create: true,
                        exclusive: false
                    }, (fsdirectory) => {
                        let directoryReader = fsdirectory.createReader();
                        directoryReader.readEntries((entries) => {
                            let k = 0
                            let filesAmount = entries.length
                            if (filesAmount == 0) {
                                resolve(1)
                            }
                            for (let i = 0; i < filesAmount; i++) {
                                let file = entries[i]
                                let filename = file.name
                                if (filename) {
                                    if (!fileMapData[filename]) {
                                        file.remove(function () {}, () => {});
                                        k += 1
                                    } else {
                                        file.file((fileInfo) => {
                                            if (fileInfo.size == fileMapData[fileInfo.name].size) {
                                                fileMapData[fileInfo.name].isexist = true
                                                fileMapData[fileInfo.name].fileEntryURL = file.toURL()

                                            } else {
                                                file.remove(function () {}, () => {});
                                            }
                                            k += 1
                                            if (k >= filesAmount) {
                                                resolve(2)
                                            }
                                        })
                                    }
                                }
                            }
                        }, () => {
                            resolve(3)
                        });
                    }, () => {
                        resolve(4)
                    })
                },
                function (error) {
                    resolve(5)
                }
            );
        })
    }

    function downloadFile(uri, fileName) {
        return new Promise(resolve => {
            window.resolveLocalFileSystemURL(cordova.file.externalDataDirectory,
                function (fs) {
                    fs.getDirectory("zipPath", {
                        create: true,
                        exclusive: false
                    }, (fsdirectory) => {
                        fsdirectory.getFile(
                            fileName, // 创建的文件名
                            {
                                create: true,
                                exclusive: true
                            },
                            // create：创建新文件，exclusive:文件已存在时抛出异常
                            function (fileEntry) {
                                let fileTransfer = new FileTransfer();
                                uri = encodeURI(uri);
                                // let fileURL = "cdvfile://localhost/temporary/path/to/js/"; //cordova.file.cacheDirectory;
                                document.getElementById('appUpdateText').innerHTML = "获取最新文件"
                                fileTransfer.onprogress = function (e) {
                                    if (e.lengthComputable) {
                                        let progress = e.loaded / e.total;
                                        // 显示下载进度
                                        progress = (progress * 100).toFixed(1);
                                        document.getElementById('appUpdateText').innerHTML = "获取最新文件中" + progress + '%'
                                    }
                                };
                                fileTransfer.download(
                                    uri, fileEntry.toURL(),
                                    function (entry) {
                                        fileMapData[fileName].fileEntryURL = entry.toURL()
                                        resolve(entry.toURL())
                                    },
                                    function (error) {
                                        resolve(false)
                                    },
                                    false
                                );
                            })
                    })
                })
        })
    }

    function getZipDirectory() {
        return new Promise(resolve => {
            window.resolveLocalFileSystemURL(cordova.file.externalDataDirectory,
                function (fs) {
                    fs.getDirectory("js", {
                        create: true,
                        exclusive: false
                    }, (fsdirectory) => {
                        console.log('getZipDirectory1')
                     
                        let directoryReader = fsdirectory.createReader();
                        directoryReader.readEntries(async (entries) => {
                            let filesAmount = entries.length
                            for (let i = 0; i < filesAmount; i++) {
                                let file = entries[i]
                                await removeFile(file)
                            }
                            resolve({
                                url: fsdirectory.toURL(),
                                internalurl: fsdirectory.toInternalURL()
                            })
                        });
                    }, () => {
                        fs.getDirectory(
                            "js", {
                                create: false
                            },
                            function (fsdirectory) {
                                console.log('getZipDirectory2')
                                resolve({
                                    url: fsdirectory.toURL(),
                                    internalurl: fsdirectory.toInternalURL()
                                })
                            })
                    })
                })
        })
    }

    function removeFile(file) {
        return new Promise(resolve => {
      
            file.remove(function () {
                resolve()
            }, () => {
                resolve()
            });
        })
    }

    function ZipFile(zipPath, zipExtractDirectory) {
        return new Promise(resolve => {
            if (zipPath) {
                var StatusCallback = function (status) {
                    if (status == 0) {
                        document.getElementById('appUpdateText').innerHTML = "获取文件成功"
                        resolve(0)
                    } else if (status == -1) {
                        document.getElementById('appUpdateText').innerHTML = "获取文件失败"
                        resolve(1)
                    }
                };
                var ProgressCallback = function (progressEvent) {
                    var percent = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                    document.getElementById('appUpdateText').innerHTML = "初始化文件" + percent + '/' + 100
                };
                window.zip.unzip(zipPath, zipExtractDirectory, StatusCallback, ProgressCallback);
            }
        })
    }

    function getFileUrl() {
        return new Promise(resolve => {
            window.resolveLocalFileSystemURL(cordova.file.externalDataDirectory,
                function (fs) {
                    fs.getDirectory(
                        "js", {
                            create: false
                        },
                        function (fsdirectory) {
                            let directoryReader = fsdirectory.createReader();
                            directoryReader.readEntries((entries) => {
                                let filesAmount = entries.length
                                for (let i = 0; i < filesAmount; i++) {
                                    let file = entries[i]

                                    if (file.name == _mainjs) {
                                        // _mainjsurl = file.toInternalURL()
                                        _mainjsurl = file.toURL()
                                    }

                                    if (file.name == _maincss) {
                                        // _maincssurl = file.toInternalURL()
                                        _maincssurl = file.toURL()
                                    }
                                }
                                resolve(true)
                            });
                        })
                })
        })
    }

}())